<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import type { element } from '@/types/freeform';
import { onBeforeUnmount, onMounted, ref } from 'vue';

let minimapContainerSize = 200;

const props = defineProps<{
    posts: element[],
    containerSize: number,
}>();

const cursorWidth = minimapContainerSize / props.containerSize * window.innerWidth;
const cursorHeight = minimapContainerSize / props.containerSize * window.innerHeight;

const x = ref(0);
const y = ref(0);

const handleUpdateCursorPosition = ()=>{
    x.value = Math.floor(minimapContainerSize / props.containerSize * window.scrollX);
    y.value = Math.floor(minimapContainerSize / props.containerSize * window.scrollY);
};

onMounted(()=>{    
    window.addEventListener('scroll', handleUpdateCursorPosition);
});

onBeforeUnmount(()=>{
    window.removeEventListener('scroll', handleUpdateCursorPosition);
});

const elementFactor = minimapContainerSize / props.containerSize;
const prevEvent = ref();

const handleCursorMove = (event:any)=>{
    if(prevEvent.value!==undefined && (((prevEvent.value.screenX!==undefined && event.screenX !== prevEvent.value.screenX) || (prevEvent.value.screenY!==undefined && event.screenY !== prevEvent.value.screenY)))||prevEvent.value===undefined){
        const factor = props.containerSize / minimapContainerSize;
        const screenX = event.offsetX - (cursorWidth/2);
        const screenY = event.offsetY - (cursorHeight/2);
        window.scrollTo(screenX * factor, screenY * factor);
        prevEvent.value = event;
    }
}

const getElementStyleProps = (element:element)=>{
    if(element !==undefined && element.styleObject!==undefined && element.styleObject.top !==undefined && element.styleObject.left !== undefined){
        const top = typeof(element.styleObject.top) === "string"?Number(element.styleObject.top.replace('px','')):element.styleObject.top;
        const left = typeof(element.styleObject.left) === "string"?Number(element.styleObject.left.replace('px','')):element.styleObject.left;
        return {
            background:element.color,
            borderRadius:element.shape==='oval'?'10px':'',
            width:element.size!==undefined?element.size.width*elementFactor+'px':250*elementFactor+'px', 
            height:element.size!==undefined?element.size.height*elementFactor+'px':250*elementFactor+'px', 
            top:top*elementFactor+'px', 
            left:left*elementFactor+'px'
        };
    }
}

</script>
<template>
    <div>
        <div class="fixed bottom-5 left-5 overflow-hidden border border-black bg-black/10 z-[2147483647] select-none" :style="{width:minimapContainerSize+10+'px',height:minimapContainerSize+10+'px'}">
            <div v-for="element,elementIndex in posts">
                <div :key="elementIndex" class="border border-black absolute" v-if="element.visible && element.authorized" :style="getElementStyleProps(element)">
                </div>
            </div>
            <div class="absolute border border-black bg-white/70" :style="{width:cursorWidth+'px',height:cursorHeight+'px',top:y+'px',left:x+'px'}"></div>
        </div>
        <div class="fixed bottom-5 left-5 overflow-hidden z-[2147483647]" :style="{width:minimapContainerSize+10+'px',height:minimapContainerSize+10+'px'}" @click="handleCursorMove">
        </div>
    </div>
</template>